11.LeetCode算法习题讲解--滑动窗口--将x减到0的最小操作数

一.题目

习题链接:1658. 将 x 减到 0 的最小操作数 - 力扣(LeetCode)

二.题目分析

给定一个数组,每次都从两边进行操作删除,让x减去数组最左侧或最右侧的数据,直到x减为0返回最小操作数

第一行也能减少的0,但不是最小操作数

三.算法原理讲解

看到这个题如果正面解决的话,其实还是比较困难的,可以定义两个指针,利用双指针来解决,但是太麻烦了,我们尝试将题目加工一下

首先题目让我们从两边进行操作,不断减少,找最小操作数,那我们是不是发现数组中剩下的不就是一个连续的数组, 既然是连续的数组,那不就是子数组。题目让我们找最小操作数,剩下的连续数据不就是最多的吗?那我们是不是可以转化为找到最长的子数组和为 nums.size() - x,这就回归到利用滑动窗口来解决这道问题了。

所以整体思路就是:

第一步:先求出整个数组的和,然后减去x,的target

第二部:利用滑动窗口,进窗口,判断窗口中的数是否大于target,若大于就循环让left不断++,直到小于target,重点是更新长度

四.代码编写

注:因为题目找到是x恰好减到0才返回,所以我们要找到恰好等于target才更新长度,然后用总长度减去找到的长度,即为最小操作数。

注:len起初要给-1,因为可能整个数组就没有符合的操作数,要返回-1;如果给0的话,就会出现 下面现象:

找到最长的数组为0,要返回16,但是你刚开始给0,这个len到最后更新完还是0,就返回-1,然后就报错,所以刚开始要给-1,如果是0就走后面那个三目判断

cpp 复制代码
class Solution {
public:
    int minOperations(vector<int>& nums, int x) {
        int i = 0, sum = 0;
        while(i < nums.size())
            sum += nums[i++];
        int left = 0, right = 0,target = sum - x;
        int len = -1,num = 0;
        while(right < nums.size())
        {
            num += nums[right++];
            while(left < right && num > target)
            {
                num -= nums[left++];
            }
            if(num == target)
            {
                len = max(len,right - left);
            }
            
        }
        return len == -1 ? -1 : nums.size() - len;
    }
};
相关推荐
启观川8 小时前
数据结构与算法 -第 3 章 常用算法-动态规划
数据结构·笔记·python·算法
码爸8 小时前
排序算法介绍
python·算法·排序算法
Interview Aid1129 小时前
SoFi 面试流程全解析:技术面试、OA 与备考指南
面试·职场和发展
动词ing9 小时前
【题目练习】算法 组合总和||
算法
longlongzihan9 小时前
链表找环:Floyd 判圈算法(LeetCode 141 & 142 )
c++·算法·leetcode·链表
专业程序开发源9 小时前
flask家电故障预测系统92491-计算机课程设计/毕业设计
vscode·python·sql·算法·flask·课程设计
Logic10110 小时前
C语言/数据结构欧几里得算法题解:长方形切割最大正方形——贪心划分计数
c语言·数据结构·算法·贪心算法·时间复杂度·空间复杂度·欧几里得算法
yi01110 小时前
LeetCode 643. 子数组最大平均数 I|从暴力枚举到滑动窗口
人工智能·笔记·python·算法·leetcode·滑动窗口
YangYang9YangYan10 小时前
2027数学与应用数学转产品经理:面试解释与项目准备
面试·职场和发展·产品经理
极光通讯10 小时前
服务器内存来料检验(IQC)实操:批次追溯、外观判定与上机验证
java·服务器·算法